import 'package:flutter/material.dart';
import 'package:hometec_ui/components/collectiion/collection_item.dart';
import 'package:hometec_ui/resources/colors/color.dart';
import 'package:hometec_ui/resources/enums/image_enum.dart';
import 'package:hometec_ui/resources/fonts/font.dart';


Widget collectionForStream(Stream<List<CollectionItem>> stream, String emptyMessage, {Function(BuildContext, int) onTap, BuildContext context, int index, Color textColor, ImageTypeEnum type = ImageTypeEnum.local, Color thumbColor = ECColor.clear}){
  return StreamBuilder<List<CollectionItem>>(
      stream: stream,
      builder: (context, snapshot){
        if(snapshot.hasData)
          return collection(snapshot.data, emptyMessage, onTap: onTap, context: context, index: index, textColor: textColor, type: type, thumbColor: thumbColor);
        else 
          return Container(
            color: ECColor.cards,
            child: Row(
              children: <Widget>[
                Expanded(
                  child: Text(emptyMessage, style: Font.captionRegular.style(color: ECColor.textColor),textAlign: TextAlign.center,),
                )
              ],
            )
          );
      }
    );
}

Widget collection(List<CollectionItem> items, String emptyMessage, {Function(BuildContext, int) onTap, BuildContext context, int index, Color textColor, ImageTypeEnum type = ImageTypeEnum.local, Color thumbColor = ECColor.clear}){
  return Padding(
    padding: EdgeInsets.symmetric(horizontal: 24, vertical: 16),
    child: ListView.separated(  
      physics: NeverScrollableScrollPhysics(),                  
      separatorBuilder: (context, index) => SizedBox(width: 16,),
      scrollDirection: Axis.horizontal,
      itemCount: items.length,
      itemBuilder: (context, index) {
      var item = items[index];
      return collectionItem(item, onTap: onTap, context: context, index: index, textColor: textColor, type: type, thumbColor: thumbColor);
      }
    ),
  );
}