import 'package:flutter/material.dart';
import 'package:hometec_ui/resources/colors/color.dart';
import 'package:hometec_ui/resources/enums/image_enum.dart';
import 'package:hometec_ui/resources/fonts/font.dart';

Widget collectionItem(CollectionItem item, {Function(BuildContext, int) onTap, BuildContext context, int index, Color textColor, ImageTypeEnum type = ImageTypeEnum.local, Color thumbColor = ECColor.clear}){
  return GestureDetector(
    onTap: () => onTap != null ? onTap(context, index): null,
    child: Column(
      mainAxisSize: MainAxisSize.min,
      crossAxisAlignment: CrossAxisAlignment.center,
      mainAxisAlignment: MainAxisAlignment.start,
      children: <Widget>[
        Container(
            decoration: BoxDecoration(
                color: thumbColor,
                border: Border.all(width: 3, color: item.getSelected() ? ECColor.primary : ECColor.clear),
                borderRadius: BorderRadius.circular(60.0)
            ),
            child: ClipRRect(
              borderRadius: BorderRadius.circular(60.0),
              child: Container(
                height: 60,
                width: 60,
                child: type == ImageTypeEnum.local ? Image.asset("images/${item.getImage()}") : Image.network(item.getImage()),
              ),
            ), 
          ),
        SizedBox(height: 8),
        Container(
          alignment: Alignment.center,
          width: 80,
          child: Text(item.getTitle(), style: Font.overlineBold.style(color: textColor == null ? item.getSelected() ? ECColor.primary : ECColor.secondary : textColor), textAlign: TextAlign.center, maxLines: 2,)
        ),
      ],
    ),
  );
}

abstract class CollectionItem {
  String getImage();
  String getTitle();
  bool getSelected();
}